DigestOutputStream (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.security, class: DigestOutputStream
Keywords: java.security.DigestOutputStream class

# Class DigestOutputStream

java.lang.Object
java.io.OutputStream
java.io.FilterOutputStream
java.security.DigestOutputStream

All Implemented Interfaces:
  `Closeable, Flushable, AutoCloseable`

public class DigestOutputStream extends FilterOutputStream
A transparent stream that updates the associated message digest using the bits going through the stream.

To complete the message digest computation, call one of the `digest` methods on the associated message digest after your calls to one of this digest output stream's `write` methods.

It is possible to turn this stream on or off (see `on`). When it is on, a call to one of the `write` methods results in an update on the message digest. But when it is off, the message digest is not updated. The default is for the stream to be on.

Since:
  1.2
See Also:
  - `MessageDigest`
  - `DigestInputStream`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected MessageDigest`
  `digest`
  The message digest associated with this stream.

  ### Fields declared in class FilterOutputStream

  `out`
  Modifier and Type
  Field
  Description
  `protected OutputStream`
  `out`
  The underlying output stream to be filtered.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DigestOutputStream(OutputStream stream, MessageDigest digest)`
  Creates a digest output stream, using the specified output stream and message digest.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `MessageDigest`
  `getMessageDigest()`
  Returns the message digest associated with this stream.
  `void`
  `on(boolean on)`
  Turns the digest function on or off.
  `void`
  `setMessageDigest(MessageDigest digest)`
  Associates the specified message digest with this stream.
  `String`
  `toString()`
  Prints a string representation of this digest output stream and its associated message digest object.
  `void`
  `write(byte[] b, int off, int len)`
  Updates the message digest (if the digest function is on) using the specified subarray, and in any case writes the subarray to the output stream.
  `void`
  `write(int b)`
  Updates the message digest (if the digest function is on) using the specified byte, and in any case writes the byte to the output stream.

  ### Methods declared in class FilterOutputStream

  `close, flush, write`
  Modifier and Type
  Method
  Description
  `void`
  `close()`
  Closes this output stream and releases any system resources associated with the stream.
  `void`
  `flush()`
  Flushes this output stream and forces any buffered output bytes to be written out to the stream.
  `void`
  `write(byte[] b)`
  Writes `b.length` bytes to this output stream.

  ### Methods declared in class OutputStream

  `nullOutputStream`
  Modifier and Type
  Method
  Description
  `static OutputStream`
  `nullOutputStream()`
  Returns a new `OutputStream` which discards all bytes.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Field Details

  - ### digest

    protected MessageDigest digest
    The message digest associated with this stream.

- ## Constructor Details

  - ### DigestOutputStream

    public DigestOutputStream(OutputStream stream, MessageDigest digest)
    Creates a digest output stream, using the specified output stream and message digest.
    Parameters:
      `stream` - the output stream.
      `digest` - the message digest to associate with this stream.

- ## Method Details

  - ### getMessageDigest

    public MessageDigest getMessageDigest()
    Returns the message digest associated with this stream.
    Returns:
      the message digest associated with this stream.
    See Also:
      - `setMessageDigest(java.security.MessageDigest)`

  - ### setMessageDigest

    public void setMessageDigest(MessageDigest digest)
    Associates the specified message digest with this stream.
    Parameters:
      `digest` - the message digest to be associated with this stream.
    See Also:
      - `getMessageDigest()`

  - ### write

    public void write(int b) throws IOException
    Updates the message digest (if the digest function is on) using the specified byte, and in any case writes the byte to the output stream. That is, if the digest function is on (see `on`), this method calls `update` on the message digest associated with this stream, passing it the byte `b`. This method then writes the byte to the output stream, blocking until the byte is actually written.
    Overrides:
      `write` in class `FilterOutputStream`
    Parameters:
      `b` - the byte to be used for updating and writing to the output stream.
    Throws:
      `IOException` - if an I/O error occurs.
    See Also:
      - `MessageDigest.update(byte)`

  - ### write

    public void write(byte[] b, int off, int len) throws IOException
    Updates the message digest (if the digest function is on) using the specified subarray, and in any case writes the subarray to the output stream. That is, if the digest function is on (see `on`), this method calls `update` on the message digest associated with this stream, passing it the subarray specifications. This method then writes the subarray bytes to the output stream, blocking until the bytes are actually written.
    Overrides:
      `write` in class `FilterOutputStream`
    Parameters:
      `b` - the array containing the subarray to be used for updating and writing to the output stream.
      `off` - the offset into `b` of the first byte to be updated and written.
      `len` - the number of bytes of data to be updated and written from `b`, starting at offset `off`.
    Throws:
      `IOException` - if an I/O error occurs.
    See Also:
      - `MessageDigest.update(byte[], int, int)`

  - ### on

    public void on(boolean on)
    Turns the digest function on or off. The default is on. When it is on, a call to one of the `write` methods results in an update on the message digest. But when it is off, the message digest is not updated.
    Parameters:
      `on` - `true` to turn the digest function on, `false` to turn it off.

  - ### toString

    public String toString()
    Prints a string representation of this digest output stream and its associated message digest object.
    Overrides:
      `toString` in class `Object`
    Returns:
      a string representation of the object